# Cashfree Verification Python SDK
![GitHub](https://img.shields.io/github/license/cashfree/cashfree-verification-sdk-python) ![Discord](https://img.shields.io/discord/931125665669972018?label=discord) ![GitHub last commit (branch)](https://img.shields.io/github/last-commit/cashfree/cashfree-verification-sdk-python/master) ![GitHub release (with filter)](https://img.shields.io/github/v/release/cashfree/cashfree-verification-sdk-python?label=latest) ![GitHub forks](https://img.shields.io/github/forks/cashfree/cashfree-verification-sdk-python) !

The Cashfree Verification Python SDK offers a convenient solution to access [Cashfree Verification APIs](https://docs.cashfree.com/docs/verification-suite-introduction) from a server-side Go  applications. 



## Documentation

Cashfree's Verification API Documentation - https://docs.cashfree.com/reference/verification-api-overview

Try out our interactive guides at [Cashfree Dev Studio](https://www.cashfree.com/devstudio) !

## Getting Started

### Installation
```bash
pip install cashfree_verification
```
### Configuration


Cashfree.XClientId = "<x-client-id>"
Cashfree.XClientSecret = "<x-client-secret>"
Cashfree.XEnvironment = Cashfree.SANDBOX
x_api_version = "2022-09-01"
```

Generate your API keys (x-client-id , x-client-secret) from [Cashfree Merchant Dashboard](https://merchant.cashfree.com/merchants/login)


## Licence

Apache Licensed. See [LICENSE.md](LICENSE.md) for more details
