# coding: utf-8

"""
    Cashfree Verification API's.

    Cashfree's Verification APIs provide different types of verification to our merchants.

    The version of the OpenAPI document: 2023-12-18
    Contact: developers@cashfree.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr, validator

class FaceLiveness200ResponseSchemaQuality(BaseModel):
    """
    FaceLiveness200ResponseSchemaQuality
    """
    blur: Optional[StrictBool] = Field(None, description="Indicates whether the image is blurry.")
    bright: Optional[StrictBool] = Field(None, description="Indicates whether the image has adequate lighting.")
    exposure: Optional[StrictStr] = Field(None, description="Assessment of image exposure level.")
    __properties = ["blur", "bright", "exposure"]

    @validator('exposure')
    def exposure_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('UNDER_EXPOSED', 'NEUTRAL', 'OVER_EXPOSED'):
            raise ValueError("must be one of enum values ('UNDER_EXPOSED', 'NEUTRAL', 'OVER_EXPOSED')")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> FaceLiveness200ResponseSchemaQuality:
        """Create an instance of FaceLiveness200ResponseSchemaQuality from a JSON string"""
        return cls.from_dict(json.loads(json_str))
    
    @classmethod
    def from_json_for_one_of(cls, json_str: str) -> FaceLiveness200ResponseSchemaQuality:
        """Create an instance of FaceLiveness200ResponseSchemaQuality from a JSON string"""
        temp_dict = json.loads(json_str)
        if "blur, bright, exposure" in temp_dict.keys():
            return cls.from_dict(json.loads(json_str))
        return None

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> FaceLiveness200ResponseSchemaQuality:
        """Create an instance of FaceLiveness200ResponseSchemaQuality from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return FaceLiveness200ResponseSchemaQuality.parse_obj(obj)

        _obj = FaceLiveness200ResponseSchemaQuality.parse_obj({
            "blur": obj.get("blur"),
            "bright": obj.get("bright"),
            "exposure": obj.get("exposure")
        })
        return _obj


